﻿using System;
using System.ServiceModel;

using Adwk.Mileage.Data;

namespace Adwk.Mileage
{
    /* マイル照会用のインターフェイス
         このインターフェイスでのやり取りは社内間のアプリケーションに使用されるので、
       型指定されたDataTableやカスタムデータ型 AdwkMStatusも使用しています。
    */
    [ServiceContract(Namespace="http://Adwk.Mileage")]
    public interface IMileageQuery2
        : IMileageQuery
    {
        // 特定の会員に関して、会員のマイル履歴を返す
        //   サービスとのやり取りの負荷を減らすため、
        // 受け取ったDataTableに照会結果を追加するのではなく、
        // ここで DataTableを作って返すだけにする
        [OperationContract]
        AdwkMileagesDataSet.会員マイル履歴DataTable QueryHistoryByMemberAndPeriod(
            string memberCode,         // [in] 会員コード
            DateTime fromDate,         // [in] 期間開始日
            DateTime untilDate,        // [in] 期間終了日(の翌日0時)
            out AdwkMStatus stat,      // [out] ステータス
            out string systemMessage); // [out] システムメッセージ
    }
}
