﻿using System;
using System.ServiceModel;

using Adwk.Mileage.Data;

namespace Adwk.Mileage
{
    // マイレージ移行のためのインターフェイス
    //   分散トランザクションは、サービスの中で完結しているので、
    // このインターフェイス自体は、トランザクションをサポートしません。
    //   社内で使用するインターフェイスなので、カスタム列挙型 AdwkMStatusも
    // 使用しています。
    [ServiceContract(Namespace="http://Adwk.Mileage")]
    public interface IMileageTransfer
    {
        [OperationContract]
        bool TransferMileByMember(
            string memberCode, string toCustomerId,
            DateTime appliedDate, int mile,
            out AdwkMStatus stat, out string systemMessage);
    }
}
