﻿using System;

using Adwk.Mileage.Data;
using Adwk.Mileage.Logic;

namespace Adwk.Mileage.Service
{
    // マイル照会関連のサービス
    public class MileageQueryService
        : IMileageQuery2              //←[1]
    {
        // 特定の会員に関して、会員情報を返す
        bool IMileageQuery.QueryInfo1ByMember(    //←[2]
            string memberCode, out MemberInfo minfo)
        {
            bool result;
            AdwkMStatus stat;
            string msg;
            var table = new AdwkMileagesDataSet.会員マイル累計DataTable();

            result = BLComp1.QueryInfo1ByMember(
                         memberCode, table, out stat, out msg);
            if (result)
            {
                // 社外公開用のサービスなので、より汎用的なデータ型に情報を移し変えて返す
                minfo = new MemberInfo()
                {
                    MemberCode = table[0].会員コード,
                    LastName = table[0].姓,
                    FirstName = table[0].名,
                    TotalMile = table[0].マイル累計
                };
            }
            else
            {
                minfo = null;
            }

            return result;
        }

        // 特定の会員に関して、会員のマイル履歴を返す
        AdwkMileagesDataSet.会員マイル履歴DataTable 
            IMileageQuery2.QueryHistoryByMemberAndPeriod( //←[3]
            string memberCode, DateTime fromDate, DateTime untilDate,
            out AdwkMStatus stat, out string systemMessage)
        {
            bool result;
            var table = new AdwkMileagesDataSet.会員マイル履歴DataTable();

            result = BLComp1.QueryHistoryByMemberAndPeriod(
                        memberCode, fromDate, untilDate, table,
                        out stat, out systemMessage);

            return table;  //エラーの場合はデータ0件のDataTable
        }
    }
}
