﻿
using System.ServiceModel;

namespace DummyExternalService
{
    // ポイント移行受付サービス
    public class ExternalService
        : IExternalService
    {
        // 加算すべきポイントの受付け
        [OperationBehavior(
            TransactionScopeRequired = true, TransactionAutoComplete = true)]
        bool IExternalService.TransferPoint(
            string fromSystem,
            string toCustomerId, string lastName, string firstName,
            int point, out int transferId, out string message)
        {

            return PointBLComp1.TransferPoint(
                fromSystem,
                toCustomerId, lastName, firstName, point,
                out transferId, out message);

            // このメソッドでは、TransactionAutoComplete = true なので、
            // 明示的な SetTransactionCompleteは呼び出さない
            // 処理されない例外が発生するとロールバックする

            // TransactionAutoComplete = false の場合の制御は、
            // OperationContext.Current.SetTransactionComplete();

            // ここから呼び出されたコンポーネントが、TransactionScoepを持つ場合、
            // 独自に制御することはできる
        }
    }
}
