﻿using System.ServiceModel;
using System.Transactions;

namespace DummyExternalService
{
    // ポイント移行受付サービス
    [ServiceContract(Namespace="http://DummyExternalService")]
    public interface IExternalService
    {
        // 加算すべきポイントの受付け
        [OperationContract]
        [TransactionFlow(TransactionFlowOption.Allowed)]
        bool TransferPoint(
            string fromSystem,    //移行元
            string toCustomerId,  //顧客Id 
            string lastName,      //姓
            string firstName,     //名
            int point,            //移行ポイント
            out int transferId,   //移行Id(移行処理単位の識別番号)
            out string message);  //メッセージ
    }

    // メソッドの属性が AutoCompleteでない場合は、
    // [ServiceContract(SessionMode=SessionMode.Required)] が必要

}
