﻿using System.ServiceModel;
using System.Collections.Generic;

using Adwk.Reservation.Dac;
using Adwk.Reservation.Data;

namespace Adwk.Reservation
{
    // 予約管理サービスの基本情報を返すサービス
    [ServiceContract(Namespace="http://Adwk.Reservation")]
    public interface IRBasicInfo
    {
        // 場所(出発地、到着地)、クラス(一等、二等)の基本情報を取得する
        // エンティティセットをそのまま返すことを想定
        [OperationContract(Name="GetBasicRouteInfo1")]
        bool GetBasicRouteInfo(
            out IEnumerable<場所> places, out IEnumerable<クラス> levels);

        // 場所(出発地、到着地)、クラス(一等、二等)の基本情報を取得する
        // エンティティの配列を返す
        [OperationContract(Name="GetBasicRouteInfo2")]
        bool GetBasicRouteInfo(
            out 場所 [] places, out クラス [] levels);

        // 場所(出発地、到着地)、クラス(一等、二等)の基本情報を取得する
        // カスタム型の配列を返す
        [OperationContract(Name="GetBasicRouteInfo3")]
        bool GetBasicRouteInfo(
            out PlaceInfo[] places, out LevelInfo[] levels);
    }
}
