﻿using System.ServiceModel;

using Adwk.Reservation.Data;

namespace Adwk.Reservation
{
    // 予約管理サービスのインターフェイス
    // (乗船関連の処理)
    [ServiceContract(Namespace="http://Adwk.Reservation")]
    public interface IRBoarding
    {
        // 乗船の手続き
        //   指定された運行コード(scheduleCode)とクラス(levelCode)に対して
        //   指定された予約コード(reservationCode)の乗客(lastName、firstName)に関する
        //   チェックイン(乗船手続き)を行います。
        //   (乗船にはあらかじめ予約が必要です。)
        //   指定された情報に一致する予約がない場合、手続きは失敗します。
        //   この時点で会員コードを指定することで、既存の予約データの会員コードを上書きすることができます。
        [OperationContract]
        bool CheckIn(
           string scheduleCode, string levelCode,
           string reservationCode, string memberCode,
           string lastName, string firstName,
           out string systemMessage);
    }
}
