﻿using System;
using System.ServiceModel;

using Adwk.Reservation.Data;
using Adwk.Reservation.Logic;

namespace Adwk.Reservation.Service
{
    // 予約管理サービス ホスト
    class Program
    {
        static void Main(string[] args)
        {
            //TestCode();

            var srv1 = new ServiceHost(typeof(RBasicInfoService));
            var srv2 = new ServiceHost(typeof(ReservationService));
            var srv3 = new ServiceHost(typeof(RBoardingService));

            srv1.Open();
            srv2.Open();
            srv3.Open();

            ShowService(srv1);
            ShowService(srv2);
            ShowService(srv3);

            Console.WriteLine("終了には、何かキーを押してください。");
            Console.ReadKey();

            srv1.Close();
        }

        static void ShowService(ServiceHost srv)
        {
            Console.WriteLine("**** {0} サービス ****", srv.Description.Name);
            foreach (var endpoint in srv.Description.Endpoints)
            {
                Console.WriteLine("     Endpoint:{0}", endpoint.Address);
            }
            Console.WriteLine();
        }

        static void TestCode()
        {
            ScheduleInfo [] list;
            AdwkRStatus stat;
            string msg;
            bool result;

            BLComp2.QuerySchedule(
                new DateTime(2011,7,1), new DateTime(2011,7,2),
                "CTWH", "SLND", "1",
                out list, out stat, out msg);

            foreach (var s in list)
            {
                DumpSchedule(Console.Out, s);
            }
            Console.WriteLine("stat={0} msg={1}\n", stat, msg);

            /*
            // 予約
            string rid;
            result = BLComp1.Reserve(
                        "01100002", "1", "0000100001", "山田", "太郎", 10000, 500,
                        "テストデータ", out rid, out stat, out msg);
            Console.WriteLine(
                "result={0}, rid={1}, stat={2}, msg={3}",
                result, rid ?? "", stat, msg );

            result = BLComp1.Reserve(
                        "01100002", "1", null, "鈴木", "次郎", 10000, 500,
                        "テストデータ", out rid, out stat, out msg);
            Console.WriteLine(
                "result={0}, rid={1}, stat={2}, msg={3}",
                result, rid ?? "", stat, msg);
            */

            // 予約確認
            ReservationInfo rinfo;
            var comp = new BLComp3();
            
            result = comp.QueryReservation1ByRCode(
               "4", "山田", "太郎", out rinfo, out stat, out msg);

            result = comp.QueryReservation1ByRCode(
               "5", "鈴木", "次郎", out rinfo, out stat, out msg);

            //予約 rsv;
            //result = comp.QueryReservation2ByRCode(
            //    "3", "山田", "太郎", out rsv, out stat, out msg);

            //result = comp.DeleteReservationByRCode(
            //    "3", out stat, out msg);

            comp.Dispose();           

            //乗船手続き
            result = BLComp4.CheckIn(
                "01100002", "1", "8", "0000100001", "山田", "太郎",
                out stat, out msg);
        }

        static void DumpSchedule(System.IO.TextWriter writer, ScheduleInfo s)
        {
            writer.WriteLine(
                s.ScheduleCode + " " + s.ScheduledDate + " " + s.CruiseId);
            writer.WriteLine(
                s.DeptCode + " " + s.DeptName + " " + s.DeptTime);
            writer.WriteLine(
                s.ArrvCode + " " + s.ArrvName + " " + s.ArrvTime);
            writer.WriteLine(
                s.Price + " " + s.Mile + " " + s.LevelCode + " " + s.LevelName);
            writer.WriteLine(
                s.Capacity + " " + s.Room);
            writer.WriteLine();
        }
    }
}
