﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Adwk.Reservation.Logic;

namespace Adwk.Reservation.Service
{
    // 予約管理サービスの基本情報を返すサービス
    public class RBasicInfoService
        : IRBasicInfo
    {
        // 場所(出発地、到着地)、クラス(一等、二等)の基本情報を取得する
        //   取得に成功した場合に戻り値はtrue
        //   エンティティセットを返すバージョン
        bool IRBasicInfo.GetBasicRouteInfo(
            out IEnumerable<Dac.場所> places, out IEnumerable<Dac.クラス> levels)
        {
            return BLComp1.GetBasicRouteInfo(out places, out levels);
        }

        // 場所(出発地、到着地)、クラス(一等、二等)の基本情報を取得する
        //   取得に成功した場合に戻り値はtrue
        //   エンティティの配列を返すバージョン
        bool IRBasicInfo.GetBasicRouteInfo(out Dac.場所[] places, out Dac.クラス[] levels)
        {
            return BLComp1.GetBasicRouteInfo(out places, out levels);
        }

        // 場所(出発地、到着地)、クラス(一等、二等)の基本情報を取得する
        //   取得に成功した場合に戻り値はtrue
        //   カスタムデータ型の配列を返すバージョン
        bool IRBasicInfo.GetBasicRouteInfo(out PlaceInfo[] places, out LevelInfo[] levels)
        {
            //System.Threading.Thread.Sleep(5000);

            return BLComp1.GetBasicRouteInfo(out places, out levels);
        }
    }
}
