﻿using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;

using System.ServiceModel.Routing;
using System.ServiceModel.Discovery;

using System.IdentityModel.Selectors;
using System.IdentityModel.Tokens;


namespace AdwkRouting
{
    class Program
    {
        static void Main(string[] args)
        {

            var serviceHost = new ServiceHost(typeof(RoutingService));
            try
            {
                // ---- ---- コードによる探索の構成 ---- ----
                    
                //クライアントが使用する探索用のエンドポイント(UDP使用の場合)
                //var endpoint1 = new UdpDiscoveryEndpoint();
                //serviceHost.Description.Endpoints.Add(endpoint1);

                //クライアントが使用する探索用のエンドポイント(wsHttpBinding使用の場合)
                //var endpoint2 = new DiscoveryEndpoint();
                //endpoint2.Binding = new WSHttpBinding();
                //endpoint2.Address = 
                //    new EndpointAddress("http://localhost:8090/adwkrouting/mydisco");
                //serviceHost.Description.Endpoints.Add(endpoint2);                    
                    
                //探索可能にする上で必要
                //var discoveryBehavior = new ServiceDiscoveryBehavior();
                //serviceHost.Description.Behaviors.Add(discoveryBehavior);
                //コードによるアナウンスメントの追加
                //discoveryBehavior.AnnouncementEndpoints.Add(new UdpAnnouncementEndpoint());

                serviceHost.Open();
                Console.WriteLine("*** ルーティングサービスが開始しました。***");
                Console.WriteLine("Press <ENTER>...");
                Console.ReadLine();

                serviceHost.Close();

            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                serviceHost.Abort();
            }
        }
    }

    public class CustomUserNameValidator : UserNamePasswordValidator
    {

        public override void Validate(string userName, string password)
        {
            if (userName == null || password == null)
            {
                throw new ArgumentNullException();
            }

            if (!(userName == "adwk" && password == "P@ssw0rd"))
            {
                throw new FaultException(
                    "adwkRouting サービス :ユーザー名、パスワードが違います");

            }
        }
    }

}
