﻿using System;
using System.Runtime.Serialization;

using System.ServiceModel;

namespace Adwk.Reservation
{
    [DataContract]
    public class ReservationInfo // 1件分の予約データ
    {
        [DataMember] public string ReservationCode; // 予約コード
        [DataMember] public string MemberCode;      // 会員コード
        [DataMember] public string LastName;        // 姓
        [DataMember] public string FirstName;       // 名
        [DataMember] public string ScheduleCode;    // 運行コード
        [DataMember] public DateTime ScheduleDate;  // 運行日
        [DataMember] public string LevelCode;       // クラスコード
        [DataMember] public string LevelName;       // クラス名
        [DataMember] public string CruiseId;        // 便名
        [DataMember] public string DeptName;        // 出発地
        [DataMember] public TimeSpan DeptTime;      // 出発時刻
        [DataMember] public string ArrvName;        // 到着地
        [DataMember] public TimeSpan ArrvTime;      // 到着時刻
        [DataMember] public decimal AppliedPrice;   // 適用料金
        [DataMember] public decimal AppliedTax;     // 適用消費税
        [DataMember] public string BoardingFlag;    // 乗船フラグ (キャンセル可否の判断のためにも必要)
        [DataMember] public DateTime? BoardingDate; // 乗船日
        [DataMember] public int? AppliedMile;       // 実績マイル(乗船していないとnull)
    }
}
