﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

using System.Web;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;  // WebFaultException

using Adwk.WebApp.ServiceReference1;  // Web上でのユーザー情報であるMemberInfoを使用


namespace Adwk.WebApp
{
    // スクリプトから必要に応じてWeb関連情報を取得するためのサービス
    [AspNetCompatibilityRequirements(
        RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class WebBasicInfoService : IWebBasicInfo
    {
        WebUserInfo IWebBasicInfo.GetWebUerInfo()
        {
            //ステータスコードを返す実験コード
            //throw new WebFaultException(
            //    System.Net.HttpStatusCode.InternalServerError);

            try
            {
                HttpContext context1 = HttpContext.Current;
                MemberInfo minfo = (MemberInfo)context1.Session[SVars.MemberInfo];
                var uinfo = new WebUserInfo()
                {
                    MemberCode = minfo.MemberCode,
                    LastName = minfo.LastName,
                    FirstName = minfo.FirstName
                };
                return uinfo;
            }
            catch
            {
                // セッションタイムアウトほか、すべて InernalServeErrorとして返す
                throw new WebFaultException(
                    System.Net.HttpStatusCode.InternalServerError);
            }

        }
    }
}