﻿<%@ Page Title="" Language="C#" MasterPageFile="~/MasterPage.master" AutoEventWireup="true" CodeBehind="ReservationConfirmOpt.aspx.cs" Inherits="Adwk.WebApp.members.ReservationConfirmOpt" %>
<asp:Content ID="Content1" ContentPlaceHolderID="HeaderPlaceHolder1" runat="server">
    <script type="text/javascript">

        // ==== WCF RESTクライアントでのオプティミスティック同時実行制御の例 ====
        // Note. オプティミスティック同時実行制御をWCF RESTクライアントで行うため、
        //       ETagを使用するコードを追加しています。
        // ====

        // 予約番号(予約コード)による予約検索
        function queryByCode() {
            // UIの変数
            var reservationCode = document.getElementById("ReservationCode");
            var page1Header = document.getElementById("Page1Header");
            var page1List = document.getElementById("Page1List");
            var page1Footer = document.getElementById("Page1Footer");
            var page1FooterNext = document.getElementById("Page1FooterNext");
            var page3Done = document.getElementById("Page3Done");

            var confirmReservationCode = document.getElementById("ConfirmReservationCode");
            var confirmName = document.getElementById("ConfirmName");
            var confirmCode = document.getElementById("ConfirmCode");
            var confirmDate = document.getElementById("ConfirmDate");
            var confirmRoute = document.getElementById("ConfirmRoute");
            var confirmTime = document.getElementById("ConfirmTime");
            var confirmClass = document.getElementById("ConfirmClass");
            var confirmFare = document.getElementById("ConfirmFare");
            var confirmStatus = document.getElementById("ConfirmStatus");
            var toDeleteConfirm = document.getElementById("ToDeleteConfirm");


            // 入力値の検証
            if (reservationCode.value == "") {
                alert("予約番号を指定してください。");
                return;
            }

            // 現在のユーザーの予約情報取得
            var rinfo = null;
            var xmlHttp = new XMLHttpRequest();
            var url = "/AdwkWebApp/members/ReservationService.svc" +
                      "/Reservations?rcode=" + reservationCode.value;
            xmlHttp.open("GET", url, false);
            xmlHttp.send();
            if (xmlHttp.status == 200) {  //ステータスコードの確認
                var result = xmlHttp.responseText;
                if (result != "") {
                    eval("rinfo =" + result + ";");
                }
            } else {
                alert("恐れ入りますが、現在、予約手続きを進めることができません。" +
                      "のちほど、はじめからやり直してください。(" +
                       xmlHttp.status + ", " + xmlHttp.statusText + ")");
                initPage();
                return;
            }

            // 予約情報の表示
            if (rinfo == null) {
                alert("該当する予約はございません。");
                initPage();
                return;
            }

            // 予約データの構築
            confirmReservationCode.innerHTML = rinfo.ReservationCode;
            confirmName.innerHTML = rinfo.LastName + "&nbsp;" + rinfo.FirstName;
            confirmDate.innerHTML = rinfo.ScheduledDate;
            confirmCode.innerHTML = rinfo.MemberCode;
            confirmRoute.innerHTML = rinfo.DeptName + "&nbsp;＞＞&nbsp;" + rinfo.ArrvName;
            confirmTime.innerHTML = rinfo.DeptTime;
            confirmClass.innerHTML = rinfo.LevelName;
            confirmFare.innerHTML = rinfo.AppliedPrice + "&nbsp;円&nbsp;＋&nbsp;（税）" +
                                    rinfo.AppliedTax + "&nbsp;円";
            if (rinfo.BoardingFlag == "1") {
                confirmStatus.innerHTML = "乗船済み";
                toDeleteConfirm.style.display = "none";  // [削除確認へ]ボタンの非表示切替
                currentReservationCode = null;           // 乗船済みは予約番号退避しない
                currentETag = null;  // ETagは退避しない(予約データを変更しないため)
            } else {
                confirmStatus.innerHTML = "未乗船";
                toDeleteConfirm.style.display = "inline";
                currentReservationCode = rinfo.ReservationCode;
                currentETag = xmlHttp.getResponseHeader("ETag"); // ETagを退避(予約データの削除の可能性があるため)
                alert(currentETag);
            }

            // ぺージ表示切替
            page1Header.style.display = "none";
            page1List.style.display = "inline";
            page1Footer.style.display = "inline";
            page1FooterNext.style.display = "none";
            page3Done.style.display = "none";
        }

        // 予約確認時の予約番号退避(ただし未乗船の場合のみ)
        var currentReservationCode;

        // 現在参照している予約データに紐付いた E-Tagを退避(削除の際に必要)
        var currentETag;

        // 最初の表示状態に戻る
        function initPage() {
            // UIの変数
            var page1Header = document.getElementById("Page1Header");
            var page1List = document.getElementById("Page1List");
            var page1Footer = document.getElementById("Page1Footer");
            var page1FooterNext = document.getElementById("Page1FooterNext");
            var page3Done = document.getElementById("Page3Done");
            // ぺージ表示切替
            page1Header.style.display = "inline";
            page1List.style.display = "none";
            page1Footer.style.display = "none";
            page1FooterNext.style.display = "none";
            page3Done.style.display = "none";
        }

        // 削除確認
        function deleteConfirm() {
            // UIの変数
            var page1Header = document.getElementById("Page1Header");
            var page1List = document.getElementById("Page1List");
            var page1Footer = document.getElementById("Page1Footer");
            var page1FooterNext = document.getElementById("Page1FooterNext");
            var page3Done = document.getElementById("Page3Done");
            // ぺージ表示切替
            page1Header.style.display = "none";
            page1List.style.display = "inline";
            page1Footer.style.display = "none";
            page1FooterNext.style.display = "inline";
            page3Done.style.display = "none";
        }

        // 削除実行
        // (queryByCode関数でcurrentReservationCodeに
        //  予約番号が設定済みであることが前提)
        function deleteExecute() {
            // UIの変数
            var page1Header = document.getElementById("Page1Header");
            var page1List = document.getElementById("Page1List");
            var page1Footer = document.getElementById("Page1Footer");
            var page1FooterNext = document.getElementById("Page1FooterNext");
            var page3Done = document.getElementById("Page3Done");
            var doneMsg = document.getElementById("DoneMsg");

            // 削除すべき予約データの予約コードを指定して呼び出し
            var xmlHttp = new XMLHttpRequest();
            var url = "/AdwkWebApp/members/ReservationService.svc" +
                      "/Reservations?rcode=" + currentReservationCode;
            xmlHttp.open("DELETE", url, false);
            xmlHttp.setRequestHeader("If-Match", currentETag); // ETagを追加
            xmlHttp.send();
            var result;
            if (xmlHttp.status == 200) {
                result = xmlHttp.responseText; // 戻り値は文字列
            } else if (xmlHttp.status == 412) {  // Precondition Failed
                // クライアントが送信時に、If-MatchヘッダーにETagを含めなかったか、
                // 含めてもサービス側のETagと一致しない場合は Precondition Failed となる
                alert("恐れ入りますが、この予約データは他から更新されたため、" +
                      "削除することができません。(" +
                          xmlHttp.status + "," + xmlHttp.statusText + ")");
                return;
            } else {
                alert("恐れ入りますが、現在、削除手続きを進めることができません。" +
                      "のちほど、はじめからやり直してください。(" +
                          xmlHttp.status + ", " + xmlHttp.statusText + ")");
                return;
            }
            // 結果表示
            doneMsg.innerHTML = eval(result);  //resultは二重引用符を含むJSON文字列なので、文字列のみ抽出 

            // ぺージ表示切替
            page1Header.style.display = "none";
            page1List.style.display = "none";
            page1Footer.style.display = "none";
            page1FooterNext.style.display = "none";
            page3Done.style.display = "inline";
        }

        // (テスト用メソッド)サービスインスタンスのハッシュ値を調べる
        function getInstanceHashCode() {
            var xmlHttp = new XMLHttpRequest();
            var url = "/AdwkWebApp/members/ReservationService.svc/GetInstanceHashCode";
            xmlHttp.open("GET", url, false);
            xmlHttp.send();
            var result;
            if (xmlHttp.status == 200) {
                result = xmlHttp.responseText; // 戻り値は文字列
            } else {
                result = "エラー（" +
                          xmlHttp.status + ", " + xmlHttp.statusText + ")";
            }
            alert(result);
        }

    </script>
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <strong>予約確認/取り消し</strong>
    <br /><br />
    <table cellpadding="2" cellspacing="0" 
           style="width: 100%; background-color: #ffffff; font-size:small;">
        <tr style="background-color: #99CCFF; font-size:medium;">
            <td>&nbsp;予約検索条件</td>
        </tr>
        <tr>
            <td>
                予約番号:&nbsp;
                <input id="ReservationCode" type="text" style="width: 64px;" />
                &nbsp;&nbsp;&nbsp;&nbsp;
                <input type="button" value="予約番号指定" onclick="queryByCode()" />
                &nbsp;&nbsp;／&nbsp;&nbsp;
                <input type="button" value="全予約" disabled="disabled" />
                <!--
                &nbsp;&nbsp;／&nbsp;&nbsp;
                <input type="button" value="GetInstanceHashCode" onclick="getInstanceHashCode()" />
                -->
            </td>
        </tr>
        <tr style="background-color: #99CCFF; font-size:medium;">
            <td>&nbsp;予約確認、および削除</td>
        </tr>
        <tr>
            <td>
                <!-- 予約一覧のヘッダー  -->
                <div id="Page1Header" style="display: inline;">
                確認または削除する予約を上記の画面からご指定ください。
                </div>
                <!-- 予約一覧ページ -->
                <div id="Page1List" style="display: none;">
                    <span>ご指定の予約が見つかりました。</span><br />
                    <table style="text-align: left">
                        <tr><td>予約番号:</td><td><span id="ConfirmReservationCode"></span></td></tr>
                        <tr><td>お名前:</td><td><span id="ConfirmName"></span></td></tr>
                        <tr><td>会員コード:</td><td><span id="ConfirmCode"></span></td></tr>
                        <tr><td>日時:</td><td><span id="ConfirmDate"></span></td></tr>
                        <tr><td>経路:</td><td><span id="ConfirmRoute"></span></td></tr>
                        <tr><td>出発時刻:</td><td><span id="ConfirmTime"></span></td></tr>
                        <tr><td>クラス:</td><td><span id="ConfirmClass"></span></td></tr>
                        <tr><td>料金:</td><td><span id="ConfirmFare"></span></td></tr>
                        <tr><td>状況:</td><td><span id="ConfirmStatus"></span></td></tr>
                    </table>
                </div>
                <!-- 制御ボタンのフッター(1つ目) -->
                <div id="Page1Footer" style="display: none;">
                    <input type="button" value="戻る" onclick="initPage()" />&nbsp;&nbsp;
                    <input type="button" id="ToDeleteConfirm" value="削除確認へ" onclick="deleteConfirm()" />
                </div>
                <!-- 制御ボタンのフッター(2つ目) -->
                <div id="Page1FooterNext" style="display: none;">
                    <span style="color: Red;">
                        本当に削除しますか？&nbsp;一旦、削除すると元には戻せません。<br />
                        削除する場合は、以下の［削除実行］ボタンをクリックしてください。<br />
                        削除しない場合は、以下の［戻る］ボタンをクリックするか、別のページに移動してください。<br />
                    </span>
                    <input type="button" value="戻る" onclick="queryByCode()" />&nbsp;&nbsp;
                    <input type="button" value="削除実行" onclick="deleteExecute()" />
                </div>
                <!-- 削除完了ページ -->
                <div id="Page3Done" style="display: none;">
                    <br />
                    <span id="DoneMsg"></span><br />
                    予約指定画面に戻ると、別の予約の確認や削除を行うことができます。<br />
                    <input type="button" value="予約検索画面へ戻る" onclick="initPage()" />
                </div>
            </td>
        </tr>
    </table>
 </asp:Content>
