﻿<%@ Page Title="" Language="C#" MasterPageFile="~/MasterPage.master" AutoEventWireup="true"
    CodeBehind="ReservationRegister.aspx.cs" Inherits="Adwk.WebApp.members.ReservationRegister" %>

<asp:Content ID="Content1" ContentPlaceHolderID="HeaderPlaceHolder1" runat="server">
    <script type="text/javascript">

        // 検索条件の選択に伴い、スケジュールの検索
        function onSelectChange() {
            // UIの変数
            var yearSelect = document.getElementById("YearSelect");
            var monthSelect = document.getElementById("MonthSelect");
            var daySelect = document.getElementById("DaySelect");
            var deptSelect = document.getElementById("DeptSelect");
            var arrvSelect = document.getElementById("ArrvSelect");
            var classSelect = document.getElementById("ClassSelect");
            var logTextArea = document.getElementById("LogTextArea");
            // 選択値の取得
            var dateVal, deptVal, arrvVal, classVal;
            try {
                dateVal = yearSelect.options[yearSelect.selectedIndex].value +
                       "-" +  monthSelect.options[monthSelect.selectedIndex].value +
                       "-" +  daySelect.options[daySelect.selectedIndex].value;
                deptVal = deptSelect.options[deptSelect.selectedIndex].value;
                arrvVal  = arrvSelect.options[arrvSelect.selectedIndex].value;
                classVal = classSelect.options[classSelect.selectedIndex].value;
            }catch(e){
                // 選択されていない場合は、selectedIndex == -1 なので
                // 例外が発生。何もせずに終了。
                return;
            }

            // 該当データの検索
            var xmlHttp = new XMLHttpRequest();
            var url = "/AdwkWebApp/members/ReservationService.svc" +
                       "/QuerySchedule" + 
                       "?date=" + dateVal +
                       "&dept=" + deptVal +
                       "&arrv=" + arrvVal +
                       "&level=" + classVal;
            //alert("url=" + url);
            xmlHttp.open("GET", url, false);
            xmlHttp.send();
            var result = xmlHttp.responseText;
            buildScheduleList(result);

            if(logTextArea != null)
                logTextArea.value = result;
            //alert(result);
        }

        // 現在表示している一覧
        var schedules;
        // 運行予定一覧のUI構築
        function buildScheduleList(result) {
            // UIの変数
            var subTitle1 = document.getElementById("SubTitle1");
            var page1List = document.getElementById("Page1List");
            var page2Confirm = document.getElementById("Page2Confirm");
            var page3Done = document.getElementById("Page3Done");
            // 予定一覧構築
            try {
                // JSON文字列を逆シリアル化
                schedules = eval(result);
                //eval("schedules=" + result + ";");

                // 運行一覧のテーブル構築
                if (schedules.length == 0) {
                    page1List.innerHTML =
                        "該当する予約可能な運行便がございません。"
                } else {
                    var tableBegin = "<table style='text-align: center;'>" +
                                 "<tr><td>[便名]</td><td>[出発]</td><td>[到着]</td>" +
                                 "<td>[空席]</td>" +
                                 "<td>&nbsp;&nbsp;ご希望の便を選択してください。</td></tr>";
                    var tableBody = "";
                    var tableEnd = "</table>";
                    for (var i = 0; i < schedules.length; i++) {
                        var registerButton;
                        if (schedules[i].Room == "0") {
                            registerButton = "<td style='text-align: left;'>&nbsp;&nbsp;" +
                                         "（予約不可）</td>";
                        } else {
                            registerButton = "<td style='text-align: left;'>&nbsp;&nbsp;" +
                                         "<input type='button' " +
                                         "onclick='confirmRegister(" + i +
                                          ");' value='予約確認へ' /></td>"
                        }
                        var row1 = "<tr>" +
                               "<td>" + schedules[i].CruiseId + "</td>" +
                               "<td>" + schedules[i].DeptTime + "</td>" +
                               "<td>" + schedules[i].ArrvTime + "</td>" +
                               "<td style='text-align: right;'>" +
                                 schedules[i].Room + "</td>" +
                               registerButton +
                               "</tr>";
                        tableBody += row1;
                    }
                    page1List.innerHTML = tableBegin + tableBody + tableEnd;
                }
            } catch (e) {
                alert("error:" + e);
                return;
            }
            //ぺージ表示切替
            subTitle1.innerHTML = "運行予定";
            page1List.style.display = "inline";
            page2Confirm.style.display = "none";
            page3Done.style.display = "none";
        }

        // 予約確認
        function confirmRegister(index) {
            // UIの変数
            var subTitle1 = document.getElementById("SubTitle1");
            var page1List = document.getElementById("Page1List");
            var page2Confirm = document.getElementById("Page2Confirm");
            var page3Done = document.getElementById("Page3Done");
            var confirmName = document.getElementById("ConfirmName");
            var confirmCode = document.getElementById("ConfirmCode");
            var confirmDate = document.getElementById("ConfirmDate");
            var confirmRoute = document.getElementById("ConfirmRoute");
            var confirmTime = document.getElementById("ConfirmTime");
            var confirmClass = document.getElementById("ConfirmClass");

            // 現在のユーザー情報取得
            var userInfo;
            var xmlHttp = new XMLHttpRequest();
            var url = "/AdwkWebApp/WebBasicInfoService.svc/GetWebUserInfo";
            xmlHttp.open("GET", url, false);
            xmlHttp.send();
            if (xmlHttp.status == 200) {  //ステータスコードの確認
                var result = xmlHttp.responseText;
                eval("userInfo =" + result + ";");
            } else {
                alert("恐れ入りますが、現在、予約手続きを進めることができません。" +
                      "のちほど、はじめからやり直してください。(" +
                       xmlHttp.status + ", " + xmlHttp.statusText + ")");
                return;
            }

            // 予約確認情報退避
            scheduleCode = schedules[index].ScheduleCode;
            levelCode = schedules[index].LevelCode;
            memberCode = userInfo.MemberCode;
            lastName = userInfo.LastName;
            firstName = userInfo.FirstName;

            // 確認表示、ユーザー情報も表示
            confirmName.innerHTML = lastName + "&nbsp;" + firstName;
            confirmCode.innerHTML = memberCode;
            confirmDate.innerHTML = schedules[index].ScheduledDate;
            confirmRoute.innerHTML = schedules[index].DeptName + "&nbsp;＞＞&nbsp;" +
                                     schedules[index].ArrvName;
            confirmTime.innerHTML = schedules[index].DeptTime;
            confirmClass.innerHTML = schedules[index].LevelName;

            //ぺージ表示切替
            subTitle1.innerHTML = "予約確認";
            page1List.style.display = "none";
            page2Confirm.style.display = "inline";
            page3Done.style.display = "none";
        }

        // 予約確認情報退避
        var scheduleCode;
        var levelCode;
        var memberCode;
        var lastName;
        var firstName;

        // 予約登録
        function postRegister() {
            // UIの変数
            var subTitle1 = document.getElementById("SubTitle1");
            var page1List = document.getElementById("Page1List");
            var page2Confirm = document.getElementById("Page2Confirm");
            var page3Done = document.getElementById("Page3Done");
            var doneMsg = document.getElementById("DoneMsg");
            
            // 予約データの構築
            var rinfo = new Object();
            rinfo.ScheduleCode = scheduleCode;
            rinfo.LevelCode = levelCode;
            rinfo.MemberCode = memberCode;
            rinfo.LastName = lastName;
            rinfo.FirstName = firstName;
            var rinfoJson;
            try {
                rinfoJson = JSON.stringify(rinfo);  // JSON文字列化(IE8以降サポート)
            }
            catch (ex) {
                rinfoJson = '{"ScheduleCode":"' + scheduleCode + '",' +
                             '"LevelCode":"' + levelCode + '",' +
                             '"MemberCode":"' + memberCode + '",' +
                             '"LastName":"' + lastName + '",' +
                             '"FirstName":"' + firstName + '"}';
            }
            
            // 予約データの投函
            var xmlHttp = new XMLHttpRequest();
            var url = "/AdwkWebApp/members/ReservationService.svc/Reservations";
            xmlHttp.open("POST", url, false);
            xmlHttp.setRequestHeader("Content-Type", "application/json");
            xmlHttp.setRequestHeader("Content-Length", rinfoJson.length);
            xmlHttp.send(rinfoJson);
            var result;
            if (xmlHttp.status == 200) {
                result = xmlHttp.responseText; // 戻り値は文字列
            } else {
                result = "恐れ入りますが、現在、予約手続きを進めることができません。<br />" +
                         "のちほど、はじめからやり直してください。(" +
                          xmlHttp.status + ", " + xmlHttp.statusText + ")";
            }
            // 結果表示
            doneMsg.innerHTML = eval(result);  //resultは二重引用符を含むJSON文字列なので、文字列のみ抽出 
            
            //ぺージ表示切替
            subTitle1.innerHTML = "予約登録の結果";
            page1List.style.display = "none";
            page2Confirm.style.display = "none";
            page3Done.style.display = "inline";
        }

    </script>
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <strong>運行予定照会/予約</strong>
    <br /><br />
    <table cellpadding="2" cellspacing="0" 
           style="width: 100%; background-color: #ffffff; font-size:small;">
        <tr style="background-color: #99CCFF; font-size:medium;">
            <td>&nbsp;運行便の指定</td>
        </tr>
        <tr>
            <td style="vertical-align: top;">
                &nbsp;&nbsp;
                <select id="YearSelect" onchange="onSelectChange()">
                    <option value="2011" selected="selected">2011</option>
                    <option value="2012">2012</option>
                </select>&nbsp;年
                &nbsp;&nbsp;
                <select id="MonthSelect" onchange="onSelectChange()">
                    <option value="01">01</option>
                    <option value="02">02</option>
                    <option value="03">03</option>
                    <option value="04">04</option>
                    <option value="05">05</option>
                    <option value="06">06</option>
                    <option value="07" selected="selected">07</option>
                    <option value="08">08</option>
                    <option value="09">09</option>
                    <option value="10">10</option>
                    <option value="11">11</option>
                    <option value="12">12</option>
                </select>&nbsp;月
                &nbsp;&nbsp;
                <select id="DaySelect" onchange="onSelectChange()">
                    <option value="01" selected="selected">01</option>
                    <option value="02">02</option>
                    <option value="03">03</option>
                    <option value="04">04</option>
                    <option value="05">05</option>
                    <option value="06">06</option>
                    <option value="07">07</option>
                    <option value="08">08</option>
                    <option value="09">09</option>
                    <option value="10">10</option>
                    <option value="11">11</option>
                    <option value="12">12</option>
                    <option value="13">13</option>
                    <option value="14">14</option>
                    <option value="15">15</option>
                    <option value="16">16</option>
                    <option value="17">17</option>
                    <option value="18">18</option>
                    <option value="19">19</option>
                    <option value="20">20</option>
                    <option value="21">21</option>
                    <option value="22">22</option>
                    <option value="23">23</option>
                    <option value="24">24</option>
                    <option value="25">25</option>
                    <option value="26">26</option>
                    <option value="27">27</option>
                    <option value="28">28</option>
                    <option value="29">29</option>
                    <option value="30">30</option>
                    <option value="31">31</option>
                </select>&nbsp;日
                &nbsp;&nbsp;
                ご希望の日付の経路とクラスを選択してください。
            </td>
        </tr>
        <tr>
            <td> 
                &nbsp;&nbsp;出発地:
                <select id="DeptSelect" size="3" 
                        onchange="onSelectChange()" style="vertical-align: top">
                    <option value="CTWH">市内埠頭</option>
                    <option value="ELND">東島</option>
                    <option value="SLND">南島</option>
                </select>
                &nbsp;到着地:
                <select id="ArrvSelect" size="3" style="vertical-align: top"
                        onchange="onSelectChange()">
                    <option value="CTWH">市内埠頭</option>
                    <option value="ELND">東島</option>
                    <option value="SLND">南島</option>
                </select>
                &nbsp;クラス:
                <select id="ClassSelect" size="3" style="vertical-align: top"
                        onchange="onSelectChange()">
                    <option value="1">一等</option>
                    <option value="2">二等</option>
                </select>
                <br />
            </td>
        </tr>
        <tr style="background-color: #99CCFF; font-size:medium;">
            <!-- ページ内の下半分のサブタイトル -->
            <td>&nbsp;<span id="SubTitle1">運行一覧</span></td>
        </tr>
        <tr>
            <td>
                <!-- 運行一覧ページ -->
                <div id="Page1List" style="display: inline;">
                    予約する運行便を上記の画面からご指定ください。
                    <!-- スクリプトで一覧作成 -->
                </div>
                <!-- 予約確認ページ -->
                <div id="Page2Confirm" style="display:none;">
                以下の内容でご指定便の予約を登録します。よろしいですか。<br />
                    <table style="text-align: left">
                        <tr><td>お名前:</td><td><span id="ConfirmName"></span></td></tr>
                        <tr><td>会員コード:</td><td><span id="ConfirmCode"></span></td></tr>
                        <tr><td>日時:</td><td><span id="ConfirmDate"></span></td></tr>
                        <tr><td>経路:</td><td><span id="ConfirmRoute"></span></td></tr>
                        <tr><td>出発時刻:</td><td><span id="ConfirmTime"></span></td></tr>
                        <tr><td>クラス:</td><td><span id="ConfirmClass"></span></td></tr>
                        <tr>
                            <td><input type="button" value="戻る" onclick="onSelectChange()" /></td>
                            <td><input type="button" value="予約" onclick="postRegister()" /></td>
                        </tr>
                    </table>
                </div>
                <!-- 予約完了ページ -->
                <div id="Page3Done" style="display: none;">
                    <br />
                    <span id="DoneMsg"></span><br />
                    <br />
                    予約指定画面に戻ると、別の予約を行うことができます。<br />
                    <input type="button" value="予約指定画面へ戻る" onclick="onSelectChange()" />
                </div>
            </td>
        </tr>
        <tr>
            <td>
                <!--
                <hr />
                取得したデータ<br />
                <textarea id="LogTextArea" rows="10" cols="100%">
                </textarea>
                -->
            </td>
        </tr>
    </table>
</asp:Content>
